Index: /java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 87)
@@ -24,4 +24,13 @@
 	private final static Logger log = Logger.getLogger(SimpleAbstractAccess.class.getName());
 
+	protected final FramsClass framsClass;
+
+	/**
+	 * @param framsClass
+	 */
+	public SimpleAbstractAccess(FramsClass framsClass) {
+		this.framsClass = framsClass;
+	}
+
 	@Override
 	public final FramsClass getFramsClass() {
@@ -29,7 +38,4 @@
 	}
 
-	public void setFramsClass(FramsClass framsClass) {
-		this.framsClass = framsClass;
-	}
 	/**
 	 * Simple String key, value class.
@@ -51,5 +57,4 @@
 	}
 
-	protected FramsClass framsClass;
 
 	@Override
@@ -141,5 +146,5 @@
 	@Override
 	public void setMin(int i) {
-		PrimitiveParam entry = framsClass.getParamEntry(i, PrimitiveParam.class);
+		PrimitiveParam<?> entry = framsClass.getParamEntry(i, PrimitiveParam.class);
 		if (entry == null) {
 			return;
@@ -160,5 +165,5 @@
 	@Override
 	public void setMax(int i) {
-		PrimitiveParam entry = framsClass.getParamEntry(i, PrimitiveParam.class);
+		PrimitiveParam<?> entry = framsClass.getParamEntry(i, PrimitiveParam.class);
 		if (entry == null) {
 			return;
@@ -188,5 +193,5 @@
 		assert framsClass != null;
 		sink.print(framsClass.getId()).print(":").breakLine();
-		for (PrimitiveParam p : filterInstanceof(framsClass.getParamEntries(), PrimitiveParam.class)) {
+		for (PrimitiveParam<?> p : filterInstanceof(framsClass.getParamEntries(), PrimitiveParam.class)) {
 			Object value = get(p, Object.class);
 			if (value == null) {
Index: /java/main/src/main/java/com/framsticks/params/UniqueListAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/UniqueListAccess.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/UniqueListAccess.java	(revision 87)
@@ -44,4 +44,5 @@
 			return getParam(i);
 		}
+		//TODO list access here
 		return Param.build().id(id).name(elementAccess.getId()).type("o " + elementAccess.getId()).finish();
 	}
Index: /java/main/src/main/java/com/framsticks/params/ValueParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ValueParam.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/ValueParam.java	(revision 87)
@@ -1,9 +1,19 @@
 package com.framsticks.params;
 
+
+import javax.annotation.concurrent.Immutable;
 
 /**
  * @author Piotr Sniegowski
  */
+@Immutable
 public abstract class ValueParam extends Param {
+
+	/**
+	 * @param builder
+	 */
+	public ValueParam(ParamBuilder builder) {
+		super(builder);
+	}
 
 	public ReassignResult<?> reassign(Object newValue, Object oldValue) throws CastFailure {
@@ -11,5 +21,5 @@
 	}
 
-	public abstract <T> T getDef(Class<T> type) throws ClassCastException;
+	public abstract <T> T getDef(Class<T> type);
 
 }
Index: /java/main/src/main/java/com/framsticks/params/annotations/AutoAppendAnnotation.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/annotations/AutoAppendAnnotation.java	(revision 87)
+++ /java/main/src/main/java/com/framsticks/params/annotations/AutoAppendAnnotation.java	(revision 87)
@@ -0,0 +1,11 @@
+package com.framsticks.params.annotations;
+
+import java.lang.annotation.ElementType;
+import java.lang.annotation.Retention;
+import java.lang.annotation.RetentionPolicy;
+import java.lang.annotation.Target;
+
+@Retention(RetentionPolicy.RUNTIME)
+@Target(ElementType.METHOD)
+public @interface AutoAppendAnnotation {
+}
Index: /java/main/src/main/java/com/framsticks/params/types/ArrayListParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/types/ArrayListParam.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/types/ArrayListParam.java	(revision 87)
@@ -4,4 +4,5 @@
 import com.framsticks.params.ArrayListAccess;
 import com.framsticks.params.CastFailure;
+import com.framsticks.params.ParamBuilder;
 import com.framsticks.params.ReassignResult;
 import com.framsticks.util.lang.Casting;
@@ -12,11 +13,14 @@
 import java.util.List;
 
+import javax.annotation.concurrent.Immutable;
+
 /**
  * @author Piotr Sniegowski
  */
+@Immutable
 public class ArrayListParam extends ListParam {
 
-	public ArrayListParam(String containedTypeName) {
-		super(containedTypeName);
+	public ArrayListParam(ParamBuilder builder) {
+		super(builder);
 	}
 
Index: /java/main/src/main/java/com/framsticks/params/types/BinaryParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/types/BinaryParam.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/types/BinaryParam.java	(revision 87)
@@ -2,12 +2,23 @@
 
 import com.framsticks.params.CastFailure;
+import com.framsticks.params.ParamBuilder;
 import com.framsticks.params.PrimitiveParam;
 import com.framsticks.params.ReassignResult;
 import com.framsticks.util.lang.Numbers;
 
+import javax.annotation.concurrent.Immutable;
+
 /**
  * @author Piotr Sniegowski
  */
-public class BinaryParam extends PrimitiveParam {
+@Immutable
+public class BinaryParam extends PrimitiveParam<Integer> {
+
+	/**
+	 * @param builder
+	 */
+	public BinaryParam(ParamBuilder builder) {
+		super(builder);
+	}
 
 	@Override
Index: /java/main/src/main/java/com/framsticks/params/types/BooleanParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/types/BooleanParam.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/types/BooleanParam.java	(revision 87)
@@ -1,5 +1,8 @@
 package com.framsticks.params.types;
 
+import javax.annotation.concurrent.Immutable;
+
 import com.framsticks.params.CastFailure;
+import com.framsticks.params.ParamBuilder;
 import com.framsticks.params.PrimitiveParam;
 import com.framsticks.params.ReassignResult;
@@ -10,8 +13,12 @@
  * @author Piotr Sniegowski
  */
-public class BooleanParam extends PrimitiveParam {
+@Immutable
+public class BooleanParam extends PrimitiveParam<Boolean> {
 
-	public BooleanParam() {
-		def = false;
+	/**
+	 * @param builder
+	 */
+	public BooleanParam(ParamBuilder builder) {
+		super(builder.defaultDef(false));
 	}
 
Index: /java/main/src/main/java/com/framsticks/params/types/ColorParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/types/ColorParam.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/types/ColorParam.java	(revision 87)
@@ -2,11 +2,24 @@
 
 import com.framsticks.params.CastFailure;
+import com.framsticks.params.ParamBuilder;
 import com.framsticks.params.PrimitiveParam;
 import com.framsticks.params.ReassignResult;
+
+import javax.annotation.concurrent.Immutable;
 
 /**
  * @author Piotr Sniegowski
  */
-public class ColorParam extends PrimitiveParam {
+@Immutable
+public class ColorParam extends PrimitiveParam<Object> {
+
+
+
+	/**
+	 * @param builder
+	 */
+	public ColorParam(ParamBuilder builder) {
+		super(builder);
+	}
 
 	@Override
Index: /java/main/src/main/java/com/framsticks/params/types/DecimalParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/types/DecimalParam.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/types/DecimalParam.java	(revision 87)
@@ -2,13 +2,20 @@
 
 import com.framsticks.params.CastFailure;
+import com.framsticks.params.ParamBuilder;
 import com.framsticks.params.ReassignResult;
+
+import javax.annotation.concurrent.Immutable;
 
 /**
  * @author Piotr Sniegowski
  */
+@Immutable
 public class DecimalParam extends NumberParam<Integer> {
 
-	public DecimalParam() {
-		def = 0;
+	/**
+	 * @param builder
+	 */
+	public DecimalParam(ParamBuilder builder) {
+		super(builder.defaultDef(0));
 	}
 
Index: /java/main/src/main/java/com/framsticks/params/types/EnumParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/types/EnumParam.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/types/EnumParam.java	(revision 87)
@@ -3,10 +3,16 @@
 import java.util.List;
 
+import com.framsticks.params.ParamBuilder;
+
+import javax.annotation.concurrent.Immutable;
+
 /**
  * @author Piotr Sniegowski
  */
+@Immutable
 public class EnumParam extends DecimalParam {
 
-	List<String> enums;
+
+	protected final List<String> enums;
 
 	/**
@@ -15,7 +21,8 @@
 	 * @param enums
 	 */
-	public EnumParam(List<String> enums) {
-		assert(enums != null);
-		this.enums = enums;
+	public EnumParam(ParamBuilder builder) {
+		super(builder);
+		this.enums = builder.getEnumValues();
+		assert(this.enums != null);
 	}
 
Index: /java/main/src/main/java/com/framsticks/params/types/EventParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/types/EventParam.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/types/EventParam.java	(revision 87)
@@ -2,9 +2,22 @@
 
 import com.framsticks.params.Param;
+import com.framsticks.params.ParamBuilder;
+
+import javax.annotation.concurrent.Immutable;
 
 /**
  * @author Piotr Sniegowski
  */
+@Immutable
 public class EventParam extends Param {
+
+
+
+	/**
+	 * @param builder
+	 */
+	public EventParam(ParamBuilder builder) {
+		super(builder);
+	}
 
 	@Override
Index: /java/main/src/main/java/com/framsticks/params/types/FloatParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/types/FloatParam.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/types/FloatParam.java	(revision 87)
@@ -2,13 +2,20 @@
 
 import com.framsticks.params.CastFailure;
+import com.framsticks.params.ParamBuilder;
 import com.framsticks.params.ReassignResult;
+
+import javax.annotation.concurrent.Immutable;
 
 /**
  * @author Piotr Sniegowski
  */
+@Immutable
 public class FloatParam extends NumberParam<Double> {
 
-	public FloatParam() {
-		def = 0.0;
+	/**
+	 * @param builder
+	 */
+	public FloatParam(ParamBuilder builder) {
+		super(builder.defaultDef(0.0));
 	}
 
Index: /java/main/src/main/java/com/framsticks/params/types/ListParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/types/ListParam.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/types/ListParam.java	(revision 87)
@@ -2,12 +2,16 @@
 
 import com.framsticks.params.CompositeParam;
+import com.framsticks.params.ParamBuilder;
+
+import javax.annotation.concurrent.Immutable;
 
 /**
  * @author Piotr Sniegowski
  */
+@Immutable
 public abstract class ListParam extends CompositeParam {
 
-	public ListParam(String containedTypeName) {
-		super(containedTypeName);
+	public ListParam(ParamBuilder builder) {
+		super(builder);
 	}
 
Index: /java/main/src/main/java/com/framsticks/params/types/NumberParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/types/NumberParam.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/types/NumberParam.java	(revision 87)
@@ -3,4 +3,5 @@
 import com.framsticks.params.CastFailure;
 import com.framsticks.params.Flags;
+import com.framsticks.params.ParamBuilder;
 import com.framsticks.params.PrimitiveParam;
 import com.framsticks.params.ReassignResult;
@@ -8,8 +9,18 @@
 import com.framsticks.util.lang.Numbers;
 
+import javax.annotation.concurrent.Immutable;
+
 /**
  * @author Piotr Sniegowski
  */
-public abstract class NumberParam<T extends Number & Comparable<T>> extends PrimitiveParam {
+@Immutable
+public abstract class NumberParam<T extends Number & Comparable<T>> extends PrimitiveParam<T> {
+
+	/**
+	 * @param builder
+	 */
+	public NumberParam(ParamBuilder builder) {
+		super(builder);
+	}
 
 	@Override
@@ -21,5 +32,5 @@
 		T v = null;
 		if (newValue instanceof String) {
-			v = Numbers.parse((String)newValue, type);
+			v = Numbers.parse((String) newValue, type);
 		} else {
 			v = Casting.tryCast(type, newValue);
Index: /java/main/src/main/java/com/framsticks/params/types/ObjectParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/types/ObjectParam.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/types/ObjectParam.java	(revision 87)
@@ -4,13 +4,17 @@
 import com.framsticks.params.CastFailure;
 import com.framsticks.params.CompositeParam;
+import com.framsticks.params.ParamBuilder;
 import com.framsticks.params.ReassignResult;
+
+import javax.annotation.concurrent.Immutable;
 
 /**
  * @author Piotr Sniegowski
  */
+@Immutable
 public class ObjectParam extends CompositeParam {
 
-	public ObjectParam(String containedTypeName) {
-		super(containedTypeName);
+	public ObjectParam(ParamBuilder builder) {
+		super(builder);
 	}
 
Index: /java/main/src/main/java/com/framsticks/params/types/ProcedureParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/types/ProcedureParam.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/types/ProcedureParam.java	(revision 87)
@@ -2,4 +2,6 @@
 
 import com.framsticks.params.Param;
+import com.framsticks.params.ParamBuilder;
+import com.framsticks.util.FramsticksException;
 import com.framsticks.util.lang.Strings;
 
@@ -9,48 +11,54 @@
 import java.util.regex.Pattern;
 
+import javax.annotation.concurrent.Immutable;
+
 /**
  * @author Piotr Sniegowski
  */
+@Immutable
 public class ProcedureParam extends Param {
-	private Param resultType;
-	private List<Param> argumentsType = new ArrayList<Param>();
+	private final Param resultType;
+	private final List<Param> argumentsType = new ArrayList<Param>();
 
 	private static Pattern addressPattern = Pattern.compile("^([^\\(]+)?\\(([^\\)]*)\\)$");
+
+	/**
+	 * @param builder
+	 */
+	public ProcedureParam(ParamBuilder builder) {
+		super(builder);
+		String signature = builder.getProcedureSignature();
+		if (Strings.notEmpty(signature)) {
+			Matcher matcher = addressPattern.matcher(signature);
+			if (!matcher.matches()) {
+				throw new FramsticksException().msg("invalid signature");
+			}
+			String result = Strings.collapse(matcher.group(1));
+			resultType = (result != null) ? parseType(result, null) : null;
+			String arguments = matcher.group(2);
+			if (!Strings.notEmpty(arguments)) {
+				return;
+			}
+			for (String a : arguments.split(",")) {
+				int space = a.indexOf(' ');
+				String type;
+				String name;
+				if (space == -1) {
+					type = a;
+					name = null;
+				} else {
+					type = a.substring(0, space);
+					name = a.substring(space + 1);
+				}
+				argumentsType.add(parseType(type, name));
+			}
+		} else {
+			resultType = null;
+		}
+	}
 
 	protected static Param parseType(String type, String name) {
 		return Param.build().type(type).name(name).finish();
 	}
-
-	public void parseSignature(String signature) throws Exception {
-		if (!Strings.notEmpty(signature)) {
-			return;
-		}
-		Matcher matcher = addressPattern.matcher(signature);
-		if (!matcher.matches()) {
-			throw new Exception("invalid signature");
-		}
-		String result = Strings.collapse(matcher.group(1));
-		if (result != null) {
-			resultType = parseType(result, null);
-		}
-		String arguments = matcher.group(2);
-		if (!Strings.notEmpty(arguments)) {
-			return;
-		}
-		for (String a : arguments.split(",")) {
-			int space = a.indexOf(' ');
-			String type;
-			String name;
-			if (space == -1) {
-				type = a;
-				name = null;
-			} else {
-				type = a.substring(0, space);
-				name = a.substring(space + 1);
-			}
-			argumentsType.add(parseType(type, name));
-		}
-	}
-
 
 	@Override
Index: /java/main/src/main/java/com/framsticks/params/types/StringParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/types/StringParam.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/types/StringParam.java	(revision 87)
@@ -2,12 +2,26 @@
 
 import com.framsticks.params.CastFailure;
+import com.framsticks.params.ParamBuilder;
 import com.framsticks.params.PrimitiveParam;
 import com.framsticks.params.ReassignResult;
 import com.framsticks.params.SinkInterface;
 
+import javax.annotation.concurrent.Immutable;
+
 /**
  * @author Piotr Sniegowski
  */
-public class StringParam extends PrimitiveParam {
+@Immutable
+public class StringParam extends PrimitiveParam<String> {
+
+
+
+	/**
+	 * @param builder
+	 */
+	public StringParam(ParamBuilder builder) {
+		super(builder);
+	}
+
 	@Override
 	public Class<?> getStorageType() {
Index: /java/main/src/main/java/com/framsticks/params/types/UniqueListParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/types/UniqueListParam.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/types/UniqueListParam.java	(revision 87)
@@ -3,4 +3,5 @@
 import com.framsticks.params.AccessInterface;
 import com.framsticks.params.CastFailure;
+import com.framsticks.params.ParamBuilder;
 import com.framsticks.params.ReassignResult;
 import com.framsticks.params.UniqueListAccess;
@@ -10,14 +11,17 @@
 import java.util.Map;
 
+import javax.annotation.concurrent.Immutable;
+
 /**
  * @author Piotr Sniegowski
  */
+@Immutable
 public class UniqueListParam extends ListParam {
 
 	final String uidName;
 
-	public UniqueListParam(String containedTypeName, String uidName) {
-		super(containedTypeName);
-		this.uidName = uidName;
+	public UniqueListParam(ParamBuilder builder) {
+		super(builder);
+		this.uidName = builder.getUid();
 	}
 
Index: /java/main/src/main/java/com/framsticks/params/types/UniversalParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/types/UniversalParam.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/types/UniversalParam.java	(revision 87)
@@ -2,11 +2,24 @@
 
 import com.framsticks.params.CastFailure;
+import com.framsticks.params.ParamBuilder;
 import com.framsticks.params.PrimitiveParam;
 import com.framsticks.params.ReassignResult;
+
+import javax.annotation.concurrent.Immutable;
 
 /**
  * @author Piotr Sniegowski
  */
-public class UniversalParam extends PrimitiveParam {
+@Immutable
+public class UniversalParam extends PrimitiveParam<Object> {
+
+
+	/**
+	 * @param builder
+	 */
+	public UniversalParam(ParamBuilder builder) {
+		super(builder);
+	}
+
 	@Override
 	public Class<?> getStorageType() {
Index: /java/main/src/main/java/com/framsticks/parsers/F0Parser.java
===================================================================
--- /java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 87)
@@ -176,5 +176,5 @@
 			return exceptions;
 		}
-		for (PrimitiveParam p : Containers.filterInstanceof(paramsC, PrimitiveParam.class)) {
+		for (PrimitiveParam<?> p : Containers.filterInstanceof(paramsC, PrimitiveParam.class)) {
 			Object def = p.getDef(Object.class);
 			if (def != null) {
@@ -209,5 +209,5 @@
 				if (currentParam != null) {
 					if (pair.value != null) {
-						PrimitiveParam vp = (PrimitiveParam) currentParam;
+						PrimitiveParam<?> vp = (PrimitiveParam<?>) currentParam;
 						int setFlag = access.set(vp, pair.value);
 						if ((setFlag & Flags.PSET_HITMIN) != 0) {
@@ -240,5 +240,5 @@
 	}
 
-	private static Exception createBoundaryHitException(AccessInterface access, PrimitiveParam param, String value, int flag) {
+	private static Exception createBoundaryHitException(AccessInterface access, PrimitiveParam<?> param, String value, int flag) {
 		boolean minimum = (flag & Flags.PSET_HITMIN) != 0;
 		String boundary = (minimum ? param.getMin(Object.class) : param.getMax(Object.class)).toString();
Index: /java/main/src/main/java/com/framsticks/parsers/F0Writer.java
===================================================================
--- /java/main/src/main/java/com/framsticks/parsers/F0Writer.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/parsers/F0Writer.java	(revision 87)
@@ -49,5 +49,5 @@
 			}
 			Object value = access.get(param, Object.class);
-			if (omitDefaults && (param instanceof PrimitiveParam) && Misc.equals(value, ((PrimitiveParam) param).getDef(Object.class))) {
+			if (omitDefaults && (param instanceof PrimitiveParam) && Misc.equals(value, ((PrimitiveParam<?>) param).getDef(Object.class))) {
 				contiguous = false;
 				continue;
Index: /java/main/src/main/java/com/framsticks/parsers/GenotypeLoader.java
===================================================================
--- /java/main/src/main/java/com/framsticks/parsers/GenotypeLoader.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/parsers/GenotypeLoader.java	(revision 87)
@@ -13,45 +13,45 @@
 	public GenotypeLoader() throws Exception {
 
-		FramsClass entries = new FramsClass("Genotype", "org", "A Genotype with the associated performance information. All but one Genotype objects are placed in Genotype Groups. There is also a single static Genotype object not associated with a group, which is used as a temporary storage by genetic operators and some functions from GenePools.");
-		entries
-			.appendGroup(new Group("Body"))
-			.appendGroup(new Group("Performance"))
-			.appendGroup(new Group("Fitness"))
-			.appendGroup(new Group("Conversions"));
+		FramsClass entries = FramsClass.build()
+			.name("Genotype")
+			.id("org")
+			.description("A Genotype with the associated performance information. All but one Genotype objects are placed in Genotype Groups. There is also a single static Genotype object not associated with a group, which is used as a temporary storage by genetic operators and some functions from GenePools.")
+			.group("Body")
+			.group("Performance")
+			.group("Fitness")
+			.group("Conversions")
+			.param(Param.build().id("name").group(0).name("Name").type(StringParam.class).min(0).max(40))
+			.param(Param.build().id("genotype").group(0).name("Genotype").type(StringParam.class).min(1))
+			.param(Param.build().id("info").group(0).name("Info").type(StringParam.class).min(1).help("Additional information or comments"))
+			.param(Param.build().id("simi").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Similarity").type(FloatParam.class))
+			.param(Param.build().id("energ0").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Starting energy").type(FloatParam.class))
+			.param(Param.build().id("strsiz").group(1).flags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).name("Body parts (deprecated; use numparts)").type(FloatParam.class))
+			.param(Param.build().id("strjoints").group(1).flags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).name("Body joints (deprecated; use numjoints)").type(FloatParam.class))
+			.param(Param.build().id("nnsiz").group(1).flags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).name("Brain size (deprecated; use numneurons)").type(FloatParam.class))
+			.param(Param.build().id("nncon").group(1).flags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).name("Brain connections (deprecated; use numconnections)").type(FloatParam.class))
+			.param(Param.build().id("numparts").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Body parts").type(FloatParam.class))
+			.param(Param.build().id("numjoints").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Body joints").type(FloatParam.class))
+			.param(Param.build().id("numneurons").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Brain size").type(FloatParam.class))
+			.param(Param.build().id("numconnections").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Brain connections").type(FloatParam.class))
+			.param(Param.build().id("num").group(2).name("Ordinal number").type(DecimalParam.class))
+			.param(Param.build().id("gnum").group(2).name("Generation").type(DecimalParam.class))
+			.param(Param.build().id("popsiz").group(2).flags(Flags.USERHIDDEN).name("Deprecated; use entities").type(DecimalParam.class))
+			.param(Param.build().id("entities").group(2).flags(Flags.DONTSAVE).name("Instances").type(DecimalParam.class).help("Copies of this genotype"))
+			.param(Param.build().id("lifespan").group(2).name("Life span").type(FloatParam.class).help("Average life span"))
+			.param(Param.build().id("velocity").group(2).name("Velocity").type(FloatParam.class).help("Average velocity"))
+			.param(Param.build().id("distance").group(2).name("Distance").type(FloatParam.class))
+			.param(Param.build().id("vertvel").group(2).name("Vertical velocity").type(FloatParam.class))
+			.param(Param.build().id("vertpos").group(2).name("Vertical position").type(FloatParam.class))
+			.param(Param.build().id("fit").group(3).flags(Flags.READONLY | Flags.DONTSAVE).name("Fitness").type(FloatParam.class))
+			.param(Param.build().id("fit2").group(3).flags(Flags.READONLY | Flags.DONTSAVE).name("Final fitness").type(FloatParam.class).help("Fitness shifted by (avg-n*stddev)"))
+			.param(Param.build().id("f0genotype").group(4).flags(Flags.READONLY | Flags.DONTSAVE).name("f0 genotype").type(StringParam.class).min(1).help("converted to f0 genotype"))
+			.param(Param.build().id("user1").group(2).name("User field 1").type(UniversalParam.class))
+			.param(Param.build().id("user2").group(2).name("User field 2").type(UniversalParam.class))
+			.param(Param.build().id("user3").group(2).name("User field 3").type(UniversalParam.class))
+			.param(Param.build().id("isValid").group(0).flags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).name("Valid").type(DecimalParam.class).min(0).max(1))
+			.param(Param.build().id("uid").group(0).flags(Flags.READONLY | Flags.USERHIDDEN).name("#").type("s").help("Unique identifier"))
+			.finish();
 
-		//getId, group-number, getFlags, getName, getType(getType min max), getHelp
-		entries
-			.append(Param.build().id("name").group(0).name("Name").type(StringParam.class).min(0).max(40))
-			.append(Param.build().id("genotype").group(0).name("Genotype").type(StringParam.class).min(1))
-			.append(Param.build().id("info").group(0).name("Info").type(StringParam.class).min(1).help("Additional information or comments"))
-			.append(Param.build().id("simi").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Similarity").type(FloatParam.class))
-			.append(Param.build().id("energ0").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Starting energy").type(FloatParam.class))
-			.append(Param.build().id("strsiz").group(1).flags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).name("Body parts (deprecated; use numparts)").type(FloatParam.class))
-			.append(Param.build().id("strjoints").group(1).flags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).name("Body joints (deprecated; use numjoints)").type(FloatParam.class))
-			.append(Param.build().id("nnsiz").group(1).flags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).name("Brain size (deprecated; use numneurons)").type(FloatParam.class))
-			.append(Param.build().id("nncon").group(1).flags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).name("Brain connections (deprecated; use numconnections)").type(FloatParam.class))
-			.append(Param.build().id("numparts").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Body parts").type(FloatParam.class))
-			.append(Param.build().id("numjoints").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Body joints").type(FloatParam.class))
-			.append(Param.build().id("numneurons").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Brain size").type(FloatParam.class))
-			.append(Param.build().id("numconnections").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Brain connections").type(FloatParam.class))
-			.append(Param.build().id("num").group(2).name("Ordinal number").type(DecimalParam.class))
-			.append(Param.build().id("gnum").group(2).name("Generation").type(DecimalParam.class))
-			.append(Param.build().id("popsiz").group(2).flags(Flags.USERHIDDEN).name("Deprecated; use entities").type(DecimalParam.class))
-			.append(Param.build().id("entities").group(2).flags(Flags.DONTSAVE).name("Instances").type(DecimalParam.class).help("Copies of this genotype"))
-			.append(Param.build().id("lifespan").group(2).name("Life span").type(FloatParam.class).help("Average life span"))
-			.append(Param.build().id("velocity").group(2).name("Velocity").type(FloatParam.class).help("Average velocity"))
-			.append(Param.build().id("distance").group(2).name("Distance").type(FloatParam.class))
-			.append(Param.build().id("vertvel").group(2).name("Vertical velocity").type(FloatParam.class))
-			.append(Param.build().id("vertpos").group(2).name("Vertical position").type(FloatParam.class))
-			.append(Param.build().id("fit").group(3).flags(Flags.READONLY | Flags.DONTSAVE).name("Fitness").type(FloatParam.class))
-			.append(Param.build().id("fit2").group(3).flags(Flags.READONLY | Flags.DONTSAVE).name("Final fitness").type(FloatParam.class).help("Fitness shifted by (avg-n*stddev)"))
-			.append(Param.build().id("f0genotype").group(4).flags(Flags.READONLY | Flags.DONTSAVE).name("f0 genotype").type(StringParam.class).min(1).help("converted to f0 genotype"))
-			.append(Param.build().id("user1").group(2).name("User field 1").type(UniversalParam.class))
-			.append(Param.build().id("user2").group(2).name("User field 2").type(UniversalParam.class))
-			.append(Param.build().id("user3").group(2).name("User field 3").type(UniversalParam.class))
-			.append(Param.build().id("isValid").group(0).flags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).name("Valid").type(DecimalParam.class).min(0).max(1))
-			.append(Param.build().id("uid").group(0).flags(Flags.READONLY | Flags.USERHIDDEN).name("#").type("s").help("Unique identifier"));
-
-		ReflectionAccess reflectionParam = new ReflectionAccess(Genotype.class, entries);
+		AccessInterface reflectionParam = new PropertiesAccess(entries);
 		addAccessInterface(reflectionParam);
 		addBreakCondition(Status.AfterObject);
